using System;
using System.Collections.Generic;
using UnityEngine;
using System.Linq;

public class DiviningRod : MVRScript
{
    protected List<Atom> _otherPersonAtoms;
    protected FreeControllerV3 _penisBase;
    protected FreeControllerV3 _penisMid;
    protected FreeControllerV3 _penisTip;
    protected Rigidbody _pelvis;
    protected Component _penisTarget;
    protected float _targetDistance;
    protected bool _insideTarget;
    protected JSONStorableBool _mouthEnabledJSON;
    protected JSONStorableBool _vaginaEnabledJSON;
    //protected JSONStorableBool _anusEnabledJSON;
    protected JSONStorableFloat _minTargetDistanceJSON;
    protected JSONStorableFloat _minRetargetDistanceJSON;
    protected JSONStorableFloat _adaptationRateJSON;
    protected JSONStorableBool _dynamicAdaptionRateJSON;

    protected void SyncOtherPersonAtoms()
    {
        _otherPersonAtoms = SuperController.singleton.GetAtoms().Where(atom => atom.type == "Person" && atom != containingAtom).ToList();
    }
    public override void Init()
    {
        try
        {
            _mouthEnabledJSON = new JSONStorableBool("Mouth Enabled", true) {
                storeType = JSONStorableParam.StoreType.Full
            };
            RegisterBool(_mouthEnabledJSON);
            CreateToggle(_mouthEnabledJSON, false);

            _vaginaEnabledJSON = new JSONStorableBool("Vagina Enabled", true) {
                storeType = JSONStorableParam.StoreType.Full
            };
            RegisterBool(_vaginaEnabledJSON);
            CreateToggle(_vaginaEnabledJSON, false);

            // unfortunately there is no suitable reference target position (that I know of)
            //_anusEnabledJSON = new JSONStorableBool("Anus Enabled", false) {
            //    storeType = JSONStorableParam.StoreType.Full
            //};
            //RegisterBool(_anusEnabledJSON);
            //CreateToggle(_anusEnabledJSON, false);

            UIDynamic spacer = CreateSpacer(false);
            spacer.height = 35f;

            _minTargetDistanceJSON = new JSONStorableFloat("Min Target Distance", 0.5f, 0.1f, 1f, false) {
                storeType = JSONStorableParam.StoreType.Full
            };
            RegisterFloat(_minTargetDistanceJSON);
            CreateSlider(_minTargetDistanceJSON, false);

            _minRetargetDistanceJSON = new JSONStorableFloat("Min Retarget Distance", 0.1f, 0f, 1f, false) {
                storeType = JSONStorableParam.StoreType.Full
            };
            RegisterFloat(_minRetargetDistanceJSON);
            CreateSlider(_minRetargetDistanceJSON, false);

            _adaptationRateJSON = new JSONStorableFloat("Adaptation Rate", 99.9f, 0f, 100f, true) {
                storeType = JSONStorableParam.StoreType.Full
            };
            RegisterFloat(_adaptationRateJSON);
            CreateSlider(_adaptationRateJSON, false);

            _dynamicAdaptionRateJSON = new JSONStorableBool("Dynamic Adaptation Rate", true) {
                storeType = JSONStorableParam.StoreType.Full
            };
            RegisterBool(_dynamicAdaptionRateJSON);
            CreateToggle(_dynamicAdaptionRateJSON, false);

            _penisTarget = null;
            SyncOtherPersonAtoms();
            _pelvis = containingAtom.rigidbodies.First(rb => rb.name == "pelvis");
            _penisBase = containingAtom.freeControllers.First(fc => fc.name == "penisBaseControl");
            _penisMid = containingAtom.freeControllers.First(fc => fc.name == "penisMidControl");
            _penisTip = containingAtom.freeControllers.First(fc => fc.name == "penisTipControl");
            _penisBase.currentPositionState = FreeControllerV3.PositionState.Off;
            _penisMid.currentPositionState = FreeControllerV3.PositionState.Off;
            _penisTip.currentPositionState = FreeControllerV3.PositionState.Off;
            //SuperController.LogMessage($"{nameof(DiviningRod)} initialized");
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningRod)}.{nameof(Init)}: {e}");
        }
    }

    public void OnEnable()
    {
        try
        {
            _penisTarget = null;
            SyncOtherPersonAtoms();
            //SuperController.LogMessage($"{nameof(DiviningRod)} enabled");
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningRod)}.{nameof(OnEnable)}: {e}");
        }
    }

    public void OnDisable()
    {
        //try
        //{
        //    SuperController.LogMessage($"{nameof(DiviningRod)} disabled");
        //}
        //catch (Exception e)
        //{
        //    SuperController.LogError($"{nameof(DiviningRod)}.{nameof(OnDisable)}: {e}");
        //}
    }

    public void OnDestroy()
    {
        //try
        //{
        //    SuperController.LogMessage($"{nameof(DiviningRod)} destroyed");
        //}
        //catch (Exception e)
        //{
        //    SuperController.LogError($"{nameof(DiviningRod)}.{nameof(OnDestroy)}: {e}");
        //}
    }

    protected bool IsInFront(Component target)
    {
        // TODO: Configurable Max Angle
        return Vector3.Dot(target.transform.position - _pelvis.transform.position, _pelvis.transform.forward) > 0.0f;    
    }

    protected void PotentialTargetUpdate(Component potentialTarget)
    {
        float targetDistance = (_penisTip.transform.position - potentialTarget.transform.position).magnitude;
        bool targetWithinDistance = targetDistance < _minTargetDistanceJSON.val;
        bool targetIsNearer = true;
        if (_penisTarget != null)
        {
            targetIsNearer = targetDistance < (_penisTip.transform.position - _penisTarget.transform.position).magnitude;
        }

        if (IsInFront(potentialTarget) && targetWithinDistance && targetIsNearer)
        {
            _penisTarget = potentialTarget;
            _targetDistance = targetDistance;
        }
    }

    protected void SyncPenisTarget()
    {
        if (!(_mouthEnabledJSON.val || _vaginaEnabledJSON.val))// || _anusEnabledJSON.val))
        {
            _penisTarget = null;
            return;
        }

        if (_penisTarget != null)
        {
            _insideTarget = Vector3.Dot(_penisTarget.transform.position - _penisTip.transform.position, _penisTip.transform.forward) <= 0.0f;
            _targetDistance = (_penisTip.transform.position - _penisTarget.transform.position).magnitude;
            if (!_insideTarget) // only consider retargeting outside of target
            {
                if (_targetDistance > _minRetargetDistanceJSON.val || !IsInFront(_penisTarget))
                {
                    _penisTarget = null;
                }
            }
        }

        if (_penisTarget == null)
        {
            foreach (Atom personAtom in _otherPersonAtoms)
            {
                if (_mouthEnabledJSON.val)
                {
                    PotentialTargetUpdate(personAtom.rigidbodies.First(rb => rb.name == "LipTrigger"));
                }
                if (_vaginaEnabledJSON.val)
                {
                    PotentialTargetUpdate(personAtom.rigidbodies.First(rb => rb.name == "LabiaTrigger"));
                }
                //if (_anusEnabledJSON.val)
                //{
                //    PotentialTargetUpdate(personAtom.rigidbodies.First(rb => rb.name == "???"));
                //}
            }
        }
    }

    // FixedUpdate is called with each physics simulation frame by Unity
    void FixedUpdate()
    {
        try
        {
            SyncPenisTarget();

            if (_adaptationRateJSON.val == 0f)
            {
                return;
            }

            if (_penisTarget == null)
            {
                _penisBase.currentRotationState = FreeControllerV3.RotationState.Off;
                _penisMid.currentRotationState = FreeControllerV3.RotationState.Off;
                _penisTip.currentRotationState = FreeControllerV3.RotationState.Off;
                return;
            }
            
            _penisBase.currentRotationState = FreeControllerV3.RotationState.On;
            _penisMid.currentRotationState = FreeControllerV3.RotationState.On;
            _penisTip.currentRotationState = FreeControllerV3.RotationState.Comply;   

            if (_insideTarget)
            {
                _penisBase.currentRotationState = FreeControllerV3.RotationState.Comply;
                _penisMid.currentRotationState = FreeControllerV3.RotationState.Off;
                _penisTip.currentRotationState = FreeControllerV3.RotationState.Off;
            }
            
            Quaternion oldRotation = _penisBase.transform.rotation;
            _penisBase.transform.LookAt(_penisTarget.transform.position, _pelvis.transform.up);

            float adaptationRate = _adaptationRateJSON.val;
            if (_dynamicAdaptionRateJSON.val && _minRetargetDistanceJSON.val < _minTargetDistanceJSON.val && !_insideTarget)
            {
                float distanceFac = Mathf.Clamp(_targetDistance - _minRetargetDistanceJSON.val / _minTargetDistanceJSON.val - _minRetargetDistanceJSON.val, 0f, 1f);
                adaptationRate *= 1f - distanceFac*distanceFac;
            }
            if (adaptationRate < 100f)
            {
                // exponential ease
                float lerpFac = Mathf.Pow(1f - adaptationRate*0.01f, Time.fixedDeltaTime);
                _penisBase.transform.rotation = Quaternion.Lerp(_penisBase.transform.rotation, oldRotation, lerpFac);
            }

            _penisMid.transform.rotation=_penisBase.transform.rotation;
            _penisTip.transform.rotation=_penisBase.transform.rotation;
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningRod)}.{nameof(FixedUpdate)}: {e}");
        }
    }
}
